Core - Bug # 63750

Bug # 63692 (Accepted): Memory consumption while bulk inserting

Status: Resolved Priority: Should have
Author: Stephan GroBberndt Category: Performance
Created: 2014-12-10 Assigned To:

Updated: 2015-01-22 Due date:

TYPO3 Version: 6.2

PHP Version:

Complexity: easy

Is Regression: No

Sprint Focus:

Subject: Avoid calling getUserObj in DataHandler->checkValue_input_Eval

Description

If the eval field is empty in a TCA input definition there is no NULL or empty check:

default:

$evalObj = GeneralUtility::getUserObj($GLOBALS['TYPO3_CONF_VARS'|['SC_OPTIONS['tce'|['formevals'][$func] . ":&' .

$func);
if (is_object($evalObj) && method_exists($evalObj, 'evaluateFieldValue')) {
$value = $evalObj->evaluateFieldValue($value, $is_in, $set);

If $func is empty, this leads to a call to unnecessary call to GeneralUtility::getUserObj(":&');

Associated revisions

Revision 61878ada - 2015-01-22 22:02 - Stephan GroBberndt

[BUGFIX] Avoid getUserObj-call for eval 'null' and non-existing hooks

If the 'eval' definition of a TCA input or text does contain 'null’ or
a value without a matching hook, we skip the useless call to
GeneralUtility::getUserObj().

This improves performance especially for bulk inserts with many text
fields.

Resolves: #63750

Releases: master, 6.2

Change-Id: 1328f6b3f5e737fa472f7385afc0a2407d16eb1f8
Reviewed-on: http://review.typo3.org/35287

Reviewed-by: Oliver Klee <typo3-coding@oliverklee.de>

Reviewed-by: Georg Ringer <georg.ringer@gmail.com>

Tested-by: Georg Ringer <georg.ringer@gmail.com>

Reviewed-by: Andreas Fernandez <andreas.fernandez@aspedia.de>

Tested-by: Andreas Fernandez <andreas.fernandez@aspedia.de>

Reviewed-by: Markus Klein <klein.t3@reelworx.at>

Tested-by: Markus Klein <klein.t3@reelworx.at>
Revision c9bc5ef4 - 2015-01-22 22:02 - Stephan GroBberndt

[BUGFIX] Avoid getUserObj-call for eval 'null' and non-existing hooks

If the 'eval' definition of a TCA input or text does contain 'null’ or
a value without a matching hook, we skip the useless call to
GeneralUtility::getUserObj().

This improves performance especially for bulk inserts with many text
fields.

Resolves: #63750

Releases: master, 6.2

Change-Id: 1328f6b3f5e737fa472f7385afc0a2407d16eb 18
Reviewed-on: http:/review.typo3.0rg/36188

Reviewed-by: Markus Klein <klein.t3@reelworx.at>

Tested-by: Markus Klein <klein.t3@reelworx.at>

History

#1 - 2014-12-11 10:29 - Mathias Schreiber
- Parent task set to #63692

#2 - 2014-12-11 10:33 - Gerrit Code Review
- Status changed from New to Under Review

Patch set 1 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.

It is available at http://review.typo3.0rg/35287

#3 - 2014-12-11 10:49 - Gerrit Code Review

Patch set 2 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.

It is available at http://review.typo3.org/35287

#4 - 2015-01-05 15:08 - Gerrit Code Review

Patch set 3 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.

It is available at http://review.typo3.0rg/35287

#5 - 2015-01-10 00:38 - Gerrit Code Review

Patch set 4 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.

It is available at http://review.typo3.0rg/35287

#6 - 2015-01-16 15:33 - Gerrit Code Review

Patch set 5 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.

It is available at http://review.typo3.org/35287
#7 - 2015-01-21 15:01 - Gerrit Code Review

Patch set 6 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at http://review.typo3.0org/35287

#8 - 2015-01-21 15:05 - Gerrit Code Review

Patch set 7 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at http://review.typo3.org/35287

#9 - 2015-01-21 16:37 - Gerrit Code Review

Patch set 8 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.

It is available at http://review.typo3.org/35287

#10 - 2015-01-21 16:38 - Gerrit Code Review

Patch set 9 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at http://review.typo3.0org/35287

#11 - 2015-01-22 22:02 - Gerrit Code Review

Patch set 1 for branch TYPO3_6-2 of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at http://review.typo3.0org/36188

#12 - 2015-01-22 22:30 - Stephan GroBberndt
- Status changed from Under Review to Resolved
- % Done changed from 0 to 100

Applied in changeset commit:61878ada16d94eb497fcdb3bc66d014cad67e541.
